import { ref as S, defineComponent as g, openBlock as r, createElementBlock as v, Fragment as y, renderSlot as b, onMounted as P, nextTick as M, createVNode as $, createSlots as j, withCtx as E, createElementVNode as t, unref as i, pushScopeId as k, popScopeId as L, getCurrentInstance as B, createBlock as V, normalizeProps as F, mergeProps as O, normalizeClass as C, createTextVNode as W, toDisplayString as G, withDirectives as f, vShow as T, computed as J } from "vue";
import { createHighlighter as Q } from "shiki";
function x() {
  const o = S("");
  async function n(e, s) {
    const l = await Q({
      langs: [],
      themes: Object.values(s)
    });
    await l.loadLanguage("templ"), o.value = l.codeToHtml(e, {
      lang: "templ",
      themes: s,
      defaultColor: !1
    });
  }
  return {
    highlightedCode: o,
    highlightCode: n
  };
}
function H() {
  const o = document.querySelector(
    ".preview-content"
  );
  o && (new MutationObserver((e) => {
    e.forEach((s) => {
      s.type === "childList" && K(s.target);
    });
  }).observe(o, { childList: !0 }), K(o));
}
function K(o) {
  o.querySelectorAll("script").forEach((e) => {
    var l;
    const s = document.createElement("script");
    s.textContent = e.textContent, (l = document.body.appendChild(s).parentNode) == null || l.removeChild(s);
  });
}
const R = /* @__PURE__ */ g({
  __name: "ConditionalWrapper",
  props: {
    isPreviewFirst: { type: Boolean }
  },
  setup(o) {
    const n = o;
    return (e, s) => (r(), v("div", null, [
      n.isPreviewFirst ? (r(), v(y, { key: 0 }, [
        b(e.$slots, "preview"),
        b(e.$slots, "code")
      ], 64)) : (r(), v(y, { key: 1 }, [
        b(e.$slots, "code"),
        b(e.$slots, "preview")
      ], 64))
    ]));
  }
}), Z = (o) => (k("data-v-1007a4b5"), o = o(), L(), o), U = { class: "container" }, X = { class: "preview" }, Y = ["innerHTML"], ee = { class: "code-content" }, te = { class: "language-templ vp-adaptive-theme" }, oe = /* @__PURE__ */ Z(() => /* @__PURE__ */ t("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), ne = /* @__PURE__ */ Z(() => /* @__PURE__ */ t("span", { class: "lang" }, "templ", -1)), se = ["innerHTML"], ie = /* @__PURE__ */ g({
  __name: "VTPCard",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const n = o, { highlightedCode: e, highlightCode: s } = x();
    return P(async () => {
      await s(n.codeContent, n.themes), M(() => {
        H();
      });
    }), (l, p) => (r(), v("div", U, [
      $(R, {
        isPreviewFirst: n.isPreviewFirst
      }, j({
        preview: E(() => [
          t("div", X, [
            t("div", {
              class: "preview-content",
              innerHTML: n.htmlContent
            }, null, 8, Y)
          ])
        ]),
        _: 2
      }, [
        n.isPreviewOnly ? void 0 : {
          name: "code",
          fn: E(() => [
            t("div", ee, [
              t("div", te, [
                oe,
                ne,
                t("span", {
                  class: "vp-code",
                  innerHTML: i(e)
                }, null, 8, se)
              ])
            ])
          ]),
          key: "0"
        }
      ]), 1032, ["isPreviewFirst"])
    ]));
  }
}), I = (o, n) => {
  const e = o.__vccOpts || o;
  for (const [s, l] of n)
    e[s] = l;
  return e;
}, z = /* @__PURE__ */ I(ie, [["__scopeId", "data-v-1007a4b5"]]), le = ["width", "height", "fill"], ae = /* @__PURE__ */ t("path", {
  "fill-rule": "evenodd",
  d: "M4.78 4.97a.75.75 0 0 1 0 1.06L2.81 8l1.97 1.97a.75.75 0 1 1-1.06 1.06l-2.5-2.5a.75.75 0 0 1 0-1.06l2.5-2.5a.75.75 0 0 1 1.06 0ZM11.22 4.97a.75.75 0 0 0 0 1.06L13.19 8l-1.97 1.97a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 0 0-1.06 0ZM8.856 2.008a.75.75 0 0 1 .636.848l-1.5 10.5a.75.75 0 0 1-1.484-.212l1.5-10.5a.75.75 0 0 1 .848-.636Z",
  "clip-rule": "evenodd"
}, null, -1), ce = [
  ae
], N = /* @__PURE__ */ g({
  __name: "CodeIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(o) {
    const n = o;
    return (e, s) => (r(), v("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: n.size,
      height: n.size,
      viewBox: "0 0 16 16",
      fill: n.fill,
      "aria-hidden": "true"
    }, ce, 8, le));
  }
}), q = (o) => (k("data-v-36a93aea"), o = o(), L(), o), re = {
  key: 1,
  class: "container"
}, de = { class: "preview" }, pe = ["innerHTML"], ve = { class: "code-section" }, ue = ["aria-controls"], he = ["id", "aria-hidden"], _e = { class: "language-templ vp-adaptive-theme" }, we = /* @__PURE__ */ q(() => /* @__PURE__ */ t("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), be = /* @__PURE__ */ q(() => /* @__PURE__ */ t("span", { class: "lang" }, "templ", -1)), ge = ["innerHTML"], me = /* @__PURE__ */ g({
  __name: "VTPCodeToggle",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const n = o, e = S(!1), { highlightedCode: s, highlightCode: l } = x(), p = B(), a = p ? p.uid.toString() : Math.random().toString(36).substring(2, 11);
    function h() {
      e.value = !e.value;
    }
    return P(async () => {
      await l(n.codeContent, n.themes), M(() => {
        H();
      });
    }), (_, c) => n.isPreviewOnly ? (r(), V(z, F(O({ key: 0 }, n)), null, 16)) : (r(), v("div", re, [
      t("div", de, [
        t("div", {
          class: "preview-content",
          innerHTML: n.htmlContent
        }, null, 8, pe)
      ]),
      t("div", ve, [
        t("button", {
          onClick: h,
          class: C(`button-${n.buttonStyle}`),
          "aria-controls": "code-content-" + i(a),
          "aria-label": "view the source code"
        }, [
          b(_.$slots, "code-icon", {}, () => [
            $(N, {
              fill: `var(--vp-button-${n.buttonStyle}-text)`
            }, null, 8, ["fill"])
          ], !0),
          W(" " + G(e.value ? "Hide Code" : "Show Code"), 1)
        ], 10, ue),
        t("div", {
          class: "code-content",
          id: "code-content-" + i(a),
          "aria-hidden": !e.value
        }, [
          t("div", null, [
            t("div", _e, [
              we,
              be,
              t("span", {
                class: "vp-code",
                innerHTML: i(s)
              }, null, 8, ge)
            ])
          ])
        ], 8, he)
      ])
    ]));
  }
}), Ue = /* @__PURE__ */ I(me, [["__scopeId", "data-v-36a93aea"]]), A = (o) => (k("data-v-9113b9ff"), o = o(), L(), o), Ce = { class: "wrapper" }, ye = {
  class: "tabs",
  role: "tablist"
}, $e = ["id", "aria-selected", "aria-controls"], fe = ["id", "aria-selected", "aria-controls"], Te = ["id"], Se = ["innerHTML"], Pe = { class: "code-content" }, Me = { class: "language-templ vp-adaptive-theme" }, ke = /* @__PURE__ */ A(() => /* @__PURE__ */ t("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), Le = /* @__PURE__ */ A(() => /* @__PURE__ */ t("span", { class: "lang" }, "templ", -1)), xe = ["innerHTML"], He = /* @__PURE__ */ g({
  __name: "VTPTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const n = o, e = S("preview"), { highlightedCode: s, highlightCode: l } = x(), p = B(), a = p ? p.uid.toString() : Math.random().toString(36).substring(2, 11), h = (_, c) => {
      (_.key === "Enter" || _.key === " ") && (e.value = c);
    };
    return P(async () => {
      await l(n.codeContent, n.themes), M(() => {
        H();
      });
    }), (_, c) => n.isPreviewOnly ? (r(), V(z, F(O({ key: 0 }, n)), null, 16)) : (r(), v(y, { key: 1 }, [
      t("div", Ce, [
        t("div", ye, [
          t("button", {
            role: "tab",
            id: "tab-preview-" + i(a),
            "aria-selected": e.value === "preview",
            class: C({ active: e.value === "preview" }),
            onClick: c[0] || (c[0] = (u) => e.value = "preview"),
            onKeydown: c[1] || (c[1] = (u) => h(u, "preview")),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(a),
            "aria-label": "preview the component"
          }, " Preview ", 42, $e),
          t("button", {
            role: "tab",
            id: "tab-code-" + i(a),
            "aria-selected": e.value === "code",
            class: C({ active: e.value === "code" }),
            onClick: c[2] || (c[2] = (u) => e.value = "code"),
            onKeydown: c[3] || (c[3] = (u) => h(u, "code")),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(a),
            "aria-label": "view the source code"
          }, " Code ", 42, fe)
        ])
      ]),
      t("div", {
        class: "tab-content",
        role: "tabpanel",
        id: "tabpanel-" + e.value + "-" + i(a)
      }, [
        f(t("div", {
          class: "preview-content",
          innerHTML: n.htmlContent
        }, null, 8, Se), [
          [T, e.value === "preview"]
        ]),
        f(t("div", Pe, [
          t("div", Me, [
            ke,
            Le,
            t("span", {
              class: "vp-code",
              innerHTML: i(s)
            }, null, 8, xe)
          ])
        ], 512), [
          [T, e.value === "code"]
        ])
      ], 8, Te)
    ], 64));
  }
}), Xe = /* @__PURE__ */ I(He, [["__scopeId", "data-v-9113b9ff"]]), Ie = ["width", "height", "fill"], Be = /* @__PURE__ */ t("path", { d: "M8 9.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z" }, null, -1), Ve = /* @__PURE__ */ t("path", {
  "fill-rule": "evenodd",
  d: "M1.38 8.28a.87.87 0 0 1 0-.566 7.003 7.003 0 0 1 13.238.006.87.87 0 0 1 0 .566A7.003 7.003 0 0 1 1.379 8.28ZM11 8a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z",
  "clip-rule": "evenodd"
}, null, -1), Fe = [
  Be,
  Ve
], Oe = /* @__PURE__ */ g({
  __name: "ViewIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(o) {
    const n = o;
    return (e, s) => (r(), v("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: n.size,
      height: n.size,
      viewBox: "0 0 16 16",
      fill: n.fill,
      "aria-hidden": "true"
    }, Fe, 8, Ie));
  }
}), D = (o) => (k("data-v-567cab52"), o = o(), L(), o), ze = { class: "wrapper" }, Ee = {
  class: "tabs",
  role: "tablist"
}, Ke = ["id", "aria-selected", "aria-controls"], Ze = ["id", "aria-selected", "aria-controls"], Ne = ["id"], qe = ["innerHTML"], Ae = { class: "code-content" }, De = { class: "language-templ vp-adaptive-theme" }, je = /* @__PURE__ */ D(() => /* @__PURE__ */ t("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), We = /* @__PURE__ */ D(() => /* @__PURE__ */ t("span", { class: "lang" }, "templ", -1)), Ge = ["innerHTML"], Je = /* @__PURE__ */ g({
  __name: "VTPIconTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const n = o, e = S("preview"), { highlightedCode: s, highlightCode: l } = x(), p = B(), a = p ? p.uid.toString() : Math.random().toString(36).substring(2, 11), h = (w) => J(() => e.value === w ? "var(--vp-button-brand-text)" : "var(--vp-button-alt-text)"), _ = h("preview"), c = h("code"), u = (w, d) => {
      (w.key === "Enter" || w.key === " ") && (e.value = d);
    };
    return P(async () => {
      await l(n.codeContent, n.themes), M(() => {
        H();
      });
    }), (w, d) => n.isPreviewOnly ? (r(), V(z, F(O({ key: 0 }, n)), null, 16)) : (r(), v(y, { key: 1 }, [
      t("div", ze, [
        t("div", Ee, [
          t("button", {
            role: "tab",
            id: "tab-preview-" + i(a),
            "aria-selected": e.value === "preview",
            class: C({ active: e.value === "preview" }),
            onClick: d[0] || (d[0] = (m) => e.value = "preview"),
            onKeydown: d[1] || (d[1] = (m) => u(m, "preview")),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(a),
            "aria-label": "preview the component"
          }, [
            b(w.$slots, "preview-icon", {}, () => [
              $(Oe, { fill: i(_) }, null, 8, ["fill"])
            ], !0)
          ], 42, Ke),
          t("button", {
            role: "tab",
            id: "tab-code-" + i(a),
            "aria-selected": e.value === "code",
            class: C({ active: e.value === "code" }),
            onClick: d[2] || (d[2] = (m) => e.value = "code"),
            onKeydown: d[3] || (d[3] = (m) => u(m, "code")),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(a),
            "aria-label": "view the source code"
          }, [
            b(w.$slots, "code-icon", {}, () => [
              $(N, { fill: i(c) }, null, 8, ["fill"])
            ], !0)
          ], 42, Ze)
        ])
      ]),
      t("div", {
        class: "tab-content",
        role: "tabpanel",
        id: "tabpanel-" + e.value + "-" + i(a)
      }, [
        f(t("div", {
          class: "preview-content",
          innerHTML: n.htmlContent
        }, null, 8, qe), [
          [T, e.value === "preview"]
        ]),
        f(t("div", Ae, [
          t("div", De, [
            je,
            We,
            t("span", {
              class: "vp-code",
              innerHTML: i(s)
            }, null, 8, Ge)
          ])
        ], 512), [
          [T, e.value === "code"]
        ])
      ], 8, Ne)
    ], 64));
  }
}), Ye = /* @__PURE__ */ I(Je, [["__scopeId", "data-v-567cab52"]]);
export {
  z as VTPCard,
  Ue as VTPCodeToggle,
  Ye as VTPIconTabs,
  Xe as VTPTabs
};
